"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.krlLogLevelCodeToHuman = exports.makeKrlLogger = void 0;
const json_log_1 = require("json-log");
function makeKrlLogger(write, baseCtx = {}) {
    function mk(ctx) {
        return {
            error: (0, json_log_1.mkLevel)(10, json_log_1.timeFns.iso, ctx, write),
            warn: (0, json_log_1.mkLevel)(20, json_log_1.timeFns.iso, ctx, write),
            info: (0, json_log_1.mkLevel)(30, json_log_1.timeFns.iso, ctx, write),
            klog: (0, json_log_1.mkLevel)(40, json_log_1.timeFns.iso, ctx, write),
            debug: (0, json_log_1.mkLevel)(50, json_log_1.timeFns.iso, ctx, write),
            child(moreCtx) {
                return mk(ctx + (0, json_log_1.stringifyPairs)(moreCtx));
            },
        };
    }
    return mk((0, json_log_1.stringifyPairs)(baseCtx));
}
exports.makeKrlLogger = makeKrlLogger;
exports.krlLogLevelCodeToHuman = {
    "10": "error",
    "20": "warn",
    "30": "info",
    "40": "klog",
    "50": "debug",
};
//# sourceMappingURL=KrlLogger.js.map